// D import file generated from 'derelict/vorbis/enc.d'
module derelict.vorbis.enc;
private 
{
	import core.stdc.config;
	import derelict.util.loader;
	import derelict.util.system;
	import derelict.vorbis.vorbis;
	static if (Derelict_OS_Windows)
	{
		enum libNames = "vorbisenc.dll, libvorbisenc-2.dll, libvorbisenc.dll";
	}
	else
	{
		static if (Derelict_OS_Mac)
		{
			enum libNames = "libvorbisenc.dylib, libvorbisenc.0.dylib";
		}
		else
		{
			static if (Derelict_OS_Posix)
			{
				enum libNames = "libvorbisenc.so, libvorbisenc.so.0, libvorbisenc.so.0.3.0";
			}
			else
			{
				static assert(0, "Need to implement libvorbisenc libnames for this operating system.");
			}
		}
	}
}
enum 
{
	OV_ECTL_RATEMANAGE_GET = 16,
	OV_ECTL_RATEMANAGE_SET = 17,
	OV_ECTL_RATEMANAGE_AVG = 18,
	OV_ECTL_RATEMANAGE_HARD = 19,
}
struct ovectl_ratemanage_arg
{
	int management_active;
	c_long bitrate_hard_min;
	c_long bitrate_hard_max;
	double bitrate_hard_window;
	c_long bitrate_av_lo;
	c_long bitrate_av_hi;
	double bitrate_av_window;
	double bitrate_av_window_center;
}
enum 
{
	OV_ECTL_RATEMANAGE2_GET = 20,
	OV_ECTL_RATEMANAGE2_SET = 21,
}
struct ovectl_ratemanage2_arg
{
	int management_active;
	c_long bitrate_limit_min_kbps;
	c_long bitrate_limit_max_kbps;
	c_long bitrate_limit_reservoir_bits;
	double bitrate_limit_reservoir_bias;
	c_long bitrate_average_kbps;
	double bitrate_average_damping;
}
enum 
{
	OV_ECTL_LOWPASS_GET = 32,
	OV_ECTL_LOWPASS_SET = 33,
	OV_ECTL_IBLOCK_GET = 48,
	OV_ECTL_IBLOCK_SET = 49,
}
extern (C) nothrow @nogc 
{
	alias da_vorbis_encode_init = int function(vorbis_info*, c_long, c_long, c_long, c_long, c_long);
	alias da_vorbis_encode_setup_managed = int function(vorbis_info*, c_long, c_long, c_long, c_long, c_long);
	alias da_vorbis_encode_setup_vbr = int function(vorbis_info*, c_long, c_long, float);
	alias da_vorbis_encode_init_vbr = int function(vorbis_info*, c_long, c_long, float);
	alias da_vorbis_encode_setup_init = int function(vorbis_info*);
	alias da_vorbis_encode_ctl = int function(vorbis_info*, int, void*);
}
__gshared 
{
	da_vorbis_encode_init vorbis_encode_init;
	da_vorbis_encode_setup_managed vorbis_encode_setup_managed;
	da_vorbis_encode_setup_vbr vorbis_encode_setup_vbr;
	da_vorbis_encode_init_vbr vorbis_encode_init_vbr;
	da_vorbis_encode_setup_init vorbis_encode_setup_init;
	da_vorbis_encode_ctl vorbis_encode_ctl;
}
class DerelictVorbisEncLoader : SharedLibLoader
{
	public this();
	protected override void loadSymbols();
}
__gshared DerelictVorbisEncLoader DerelictVorbisEnc;
shared static this();
